<?php

include_once(__DIR__.'/vendor/autoload.php');

// load admin related code
$this->on('app.admin.init', function () {
    include(__DIR__ . '/admin.php');
});

// Autopilot api
$this->module('autopilot')->extend([

    '_apiKey' => null,
    '_client' => null,

    'apiKey' => function() {

        if (!isset($this->_apiKey)) {
            $this->_apiKey = $this->app->retrieve('autopilot/openAI/apiKey');
        }

        return $this->_apiKey;
    },

    'client' => function() {

        if (!isset($this->_client)) {

            $this->_client = \OpenAI::factory()
                                ->withApiKey($this->apiKey())
                                //->withBaseUri('openai.example.com/v1') // default: api.openai.com/v1
                                ->withHttpClient(new \GuzzleHttp\Client([]))
                                ->make();
        }

        return $this->_client;
    },
]);
