<?php

// load admin related code
$this->on('app.admin.init', function() {

    $this->helper('license')->require();

});


// events
$this->on('app.filestorage.init', function(&$storages) {

    $config = $this->retrieve('cloudStorage');

    if (!$config) {
        return;
    }

    foreach ($config as $key => $settings) {

        if (!$settings) {
            continue;
        }

        $type = $settings['type'] ?? 's3';

        $settings['prefix'] = $settings['prefix'] ?? '';

        switch ($type) {

            case 's3':

                if (!isset($settings['key'], $settings['secret'], $settings['region'], $settings['bucket'])) {
                    break;
                }

                $url = $settings['url'] ?? "https://s3.{$settings['region']}.amazonaws.com/{$settings['bucket']}";

                if (!isset($settings['url']) && $settings['prefix']) {
                    $url .= "/{$settings['prefix']}";
                }

                $client = new Aws\S3\S3Client(array_merge([
                        'credentials' => [
                            'key'    => $settings['key'],
                            'secret' => $settings['secret']
                        ],
                        'region'  => $settings['region'],
                        'version' => $settings['version'] ?? 'latest',
                ], isset($settings['endpoint']) ? [
                    'endpoint' => $settings['endpoint']
                ] : []));

                $storages[$key] = [
                    'adapter' => 'League\Flysystem\AwsS3V3\AwsS3V3Adapter',
                    'args'    => [$client, $settings['bucket'], $settings['prefix']],
                    'mount'   => true,
                    'url'     => $url,
                    'visibility' => $settings['visibility'] ?? 'public',
                ];

                break;
        }

    }
});

$this->on('assets.asset.remove', function($asset) {

    // remove cached asset if cloudstorage is used
    if ($cached = $this->path("#uploads:{$asset['path']}")) {
        unlink($cached);
    }
});
