<?php

$this->helper('license')->require();

// Register routes
$this->bindClass('Layout\\Controller\\Settings', '/layout-components');

$this->bind('/layout/components', function() {

    $this->helper('session')->close();

    $components = new ArrayObject($this->helper('layoutComponents')->components());

    $this->trigger('layout.components.collect', [$components]);

    if ($this->param('list', 0)) {

        $this->response->mime = 'json';

        $list = [];

        foreach ($components as $name => $component) {

            $component['name'] = $name;
            $list[] = $component;
        }

        return $list;
    }

    $this->response->mime = 'js';

    return 'export default '.json_encode($components);
});

// events

$this->on('app.layout.assets', function(array &$assets) {
    $assets[] = ['src' => 'layout:assets/js/layout.js', 'type' => 'module'];
    $assets[] = 'layout:assets/css/layout.css';
});

$this->on('app.settings.collect', function($settings) {

    $settings['Addons'][] = [
        'icon' => 'layout:assets/icons/component.svg',
        'route' => '/layout-components',
        'label' => 'Layout Components',
        'permission' => 'layout/components/manage'
    ];
});

$this->on('app.permissions.collect', function($permissions) {

    $permissions['Layout'] = [
        'layouts/components/manage' => 'Manage components',
    ];
});
